*      function EXISTS('name') eg. print exists('qlib_use')    PA Borman 91
*      returns 1 for true, 0 for false so extension not loaded

       section basic
       filetype 0

       move.w  $110,a2          ; bp.init
       lea     table,a1
       jmp     (a2)

table  dc.w    0
       dc.w    0
       dc.w    1
       dc.w    start-*
       dc.b    6,'EXISTS',0
       dc.w    0 

start  cmpa.l  a3,a5
       beq     err_bp              ; no parameters
       movea.w $116,a2             ; fetch strings
       jsr     (a2)
       bne     err_bp              ; error
       subq.w  #1,d3
       bne     err_bp              ; one only
       moveq   #0,d5
       move.w  (a6,a1.l),d5        ; length of string
       tst.w   d5
       beq.s   err_bp              ; must be non zero
*
       move.l  $8(a6),d0           ; offset to end of basic buffer
       subq.l  #2,d0               ; allow room for length word
       sub.l   (a6),d0             ; d0 is now buffer length
       cmp.w   d0,d5               ; does the string fit?
       bcs.s   room                ; yes
       moveq   #-5,d0              ; no
       bra.s   err_bad             ; error buffer full. give up
*
room   lea     2(a1),a5            ; from relative to a6
       movea.l (a6),a2             ; to   relative to a6
       move.w  d5,d1               ; length counter
       subq.w  #1,d1               ; preset for dbra

loop   cmpi.b  #$60,(a6,a5.l)      ; ` sign (1 before a)
       blt.s   is_upp              ; branch if upper case
       subi.b  #$20,(a6,a5.l)      ; change case

is_upp move.b  (a6,a5.l),(a6,a2.l) ; copy string to buffer
       addq.l  #1,a5               ; point to next character
       addq.l  #1,a2               ; point to next buffer space
       dbra    d1,loop
       move.l  d5,d1               ; reset length
       bclr    #0,d1               ; and make even
       bne.s   iseven
       addq.w  #2,d1               ; adjust to new length

iseven lea     2(a1),a1            ; move stack past the length word
       adda.l  d1,a1               ; and the string
       move.l  a1,$58(a6)          ; reset stack pointer
       moveq   #0,d4               ; clear 'offset in table' pointer
       moveq   #0,d0               ; preset signal 'not found'

nloop  addq.l  #8,d4
       movea.l $18(a6),a3          ; name table base
       movea.l $1c(a6),a2          ; name table pointer
       movea.l a2,a5
       suba.l  d4,a5               ; are we still in the table
       cmpa.l  a5,a3
       bgt.s   return              ; no - past end, so quit
       move.w  (a6,a5.l),d1        ; yes - fetch first word for this entry
       cmpi.w  #$0800,d1           ; is it a proc or fn ?
       blt.s   nloop               ; no
       suba.l  a3,a3               ; yes
       movea.w 2(a6,a5.l),a3       ; second word points to name
       adda.l  $20(a6),a3          ; offset within name list
       bsr.s   compare             ; is it the right one ?
       tst.l   d0
       bne.s   return              ; yes, return 1
       bra.s   nloop               ; no - try next entry

err_bp moveq   #-$0f,d0            ; bad parameter
err_bad
       rts
*
* the 'return' value is held in d0: 1=found, 0=not found
*
return movea.l $58(a6),a1
       subq.w  #2,a1               ; set stack space for one word
       move.l  a1,$58(a6)
       move.w  d0,(a6,a1.l)        ; store value to return on stack
       moveq   #3,d4               ; signal 'word integer'
       bra.s   err_ok              ; no errors
*                                  ; back to basic

compare
       move.b  (a6,a3.l),d2        ; length of current name is
       addq.l  #1,a3               ; only a byte not a word
       ext.w   d2
       cmp.w   d2,d5               ; is the length right?
       beq.s   chknam              ; yes
err_ok moveq   #0,d0               ; no, signal 'not found'
       rts                         ; and return

chknam movea.l (a6),a2             ; set up pointer to name in buffer
       move.w  d5,d1               ; and length
       subq.w  #1,d1               ; preset for dbra

cmatch move.b  (a6,a2.l),d3
       cmp.b   (a6,a3.l),d3        ; compare a character
       bne.s   err_ok              ; no match
       addq.l  #1,a2
       addq.l  #1,a3
       dbra    d1,cmatch           ; match, so try next one
       moveq   #1,d0               ; all match, so return 1 for 'found'
       rts

       END
